conditions =
{
	on = 
	{
		arguments = true,
		argtype = "block",
		
	},
	near = 
	{
		arguments = true,
		argtype = "block",
	},
	facing = 
	{
		arguments = true,
		argtype = "block",
		argextra = {"right","up","left","down"},
	},
	alone =
	{
		arguments = false,
	},
	alone2 =
	{
		arguments = false,
	},
	never =
	{
		arguments = false,
	},
}

function testcond(conds,unitid,x_,y_)
	local result = true
	
	local x,y,name,dir = 0,0,"",4
	
	-- 0 = bug, 1 = level, 2 = empty
	
	if (unitid ~= 2) and (unitid ~= 0) and (unitid ~= 1) then
		local unit = mmf.newObject(unitid)
		x = unit.values[XPOS]
		y = unit.values[YPOS]
		name = unit.strings[UNITNAME]
		dir = unit.values[DIR]
		
		if (unit.strings[UNITTYPE] == "text") then
			name = "text"
		end
	elseif (unitid == 2) then
		x = x_
		y = y_
		name = "empty"
	end
	
	if (unitid == 0) then
		print("WARNING!! Unitid is zero!!")
	end
	
	if (conds ~= nil) then
		if (#conds > 0) then
			local valid = false
			
			for i,cond in ipairs(conds) do
				local condtype = cond[1]
				local params = cond[2]
				
				local extras = {}
				
				local isnot = string.sub(condtype, 1, 3)
				
				if (isnot == "not") then
					isnot = string.sub(condtype, 5)
				else
					isnot = condtype
				end

				local conddata = conditions[isnot]
				if (conddata.argextra ~= nil) then
					extras = conddata.argextra
				end
				
				if (condtype == "never") then
					result = false
					valid = true
				elseif (condtype == "on") then
					valid = true
					local allfound = 0
					local alreadyfound = {}
					
					local tileid = x + y * roomsize
					
					if (#params > 0) then
						for a,b in ipairs(params) do
							if (b ~= "empty") then
								if (unitmap[tileid] ~= nil) then
									for c,d in ipairs(unitmap[tileid]) do
										if (d ~= unitid) then
											local unit = mmf.newObject(d)
											local name_ = unit.strings[UNITNAME]
											
											if (unit.strings[UNITTYPE] == "text") then
												name_ = "text"
											end
											
											if (name_ == b) and (alreadyfound[b] == nil) then
												alreadyfound[b] = 1
												allfound = allfound + 1
											end
										end
									end
								else
									print("unitmap is nil at " .. tostring(x) .. ", " .. tostring(y) .. " for object " .. unit.strings[UNITNAME] .. " (" .. tostring(unitid) .. ")!")
								end
							else
								result = false
							end	
						end
					else
						print("no parameters given!")
					end
					
					if (allfound ~= #params) then
						result = false
					end
				elseif (condtype == "not on") then
					valid = true
					local tileid = x + y * roomsize
					
					if (#params > 0) then
						for a,b in ipairs(params) do
							if (b ~= "empty") then
								if (unitmap[tileid] ~= nil) then
									for c,d in ipairs(unitmap[tileid]) do
										if (d ~= unitid) then
											local unit = mmf.newObject(d)
											local name_ = unit.strings[UNITNAME]
											
											if (unit.strings[UNITTYPE] == "text") then
												name_ = "text"
											end
											
											if (name_ == b) then
												result = false
											end
										end
									end
								else
									print("unitmap is nil at " .. tostring(x) .. ", " .. tostring(y) .. "!")
								end
							else
								local onempty = true

								if (unitmap[tileid] ~= nil) then 
									if (#unitmap[tileid] > 1) then
										onempty = false
									end
								end
								
								if onempty then
									result = false
								end
							end
						end
					else
						print("no parameters given!")
					end
				elseif (condtype == "facing") and (unitid ~= 2) then
					valid = true
					local allfound = 0
					local alreadyfound = {}
					
					local ndrs = ndirs[dir+1]
					local ox = ndrs[1]
					local oy = ndrs[2]
					
					local tileid = (x + ox) + (y + oy) * roomsize
					
					if (#params > 0) then
						for a,b in ipairs(params) do
							if (b ~= "empty") then
								if (stringintable(b,extras) == false) then
									if (unitmap[tileid] ~= nil) then
										for c,d in ipairs(unitmap[tileid]) do
											if (d ~= unitid) then
												local unit = mmf.newObject(d)
												local name_ = unit.strings[UNITNAME]
												
												if (unit.strings[UNITTYPE] == "text") then
													name_ = "text"
												end
												
												if (name_ == b) and (alreadyfound[b] == nil) then
													alreadyfound[b] = 1
													allfound = allfound + 1
												end
											end
										end
									end
								else
									if ((b == "right") and (dir == 0)) or ((b == "up") and (dir == 1)) or ((b == "left") and (dir == 2)) or ((b == "down") and (dir == 3)) then
										alreadyfound[b] = 1
										allfound = allfound + 1
									end
								end
							else
								if (unitmap[tileid] == nil) or (#unitmap[tileid] == 0) then
									if (alreadyfound[b] == nil) then
										alreadyfound[b] = 1
										allfound = allfound + 1
									end
								end
							end	
						end
					else
						print("no parameters given!")
					end
					
					if (allfound ~= #params) then
						result = false
					end
				elseif (condtype == "not facing") and (unitid ~= 2) then
					valid = true

					local ndrs = ndirs[dir+1]
					local ox = ndrs[1]
					local oy = ndrs[2]
					
					local tileid = (x + ox) + (y + oy) * roomsize
					
					if (#params > 0) then
						for a,b in ipairs(params) do
							if (b ~= "empty") then
								if (stringintable(b, extras) == false) then
									if (unitmap[tileid] ~= nil) then
										for c,d in ipairs(unitmap[tileid]) do
											if (d ~= unitid) then
												local unit = mmf.newObject(d)
												local name_ = unit.strings[UNITNAME]
												
												if (unit.strings[UNITTYPE] == "text") then
													name_ = "text"
												end
												
												if (name_ == b) then
													result = false
												end
											end
										end
									end
								else
									if ((b == "right") and (dir == 0)) or ((b == "up") and (dir == 1)) or ((b == "left") and (dir == 2)) or ((b == "down") and (dir == 3)) then
										result = false
									end
								end
							else
								if (unitmap[tileid] == nil) or (#unitmap[tileid] == 0) then
									result = false
								end
							end	
						end
					else
						print("no parameters given!")
					end
				elseif (condtype == "near") then
					valid = true
					local allfound = 0
					local alreadyfound = {}
					
					if (#params > 0) then
						for a,b in ipairs(params) do
							for g=-1,1 do
								for h=-1,1 do
									if (b ~= "empty") then
										local tileid = (x + g) + (y + h) * roomsize
										if (unitmap[tileid] ~= nil) then
											for c,d in ipairs(unitmap[tileid]) do
												if (d ~= unitid) then
													local unit = mmf.newObject(d)
													local name_ = unit.strings[UNITNAME]
													
													if (unit.strings[UNITTYPE] == "text") then
														name_ = "text"
													end
													
													if (name_ == b) and (alreadyfound[b] == nil) then
														alreadyfound[b] = 1
														allfound = allfound + 1
													end
												end
											end
										end
									else
										local nearempty = true
								
										local tileid = (x + g) + (y + h) * roomsize
										if (unitmap[tileid] ~= nil) then 
											if (#unitmap[tileid] > 1) then
												nearempty = false
											end
										end
										
										if nearempty then
											alreadyfound[b] = 1
											allfound = allfound + 1
										end
									end
								end
							end
						end
					else
						print("no parameters given!")
					end

					if (allfound ~= #params) then
						result = false
					end
				elseif (condtype == "not near") then
					valid = true
					
					if (#params > 0) then
						for a,b in ipairs(params) do
							for g=-1,1 do
								for h=-1,1 do
									if (b ~= "empty") then
										local tileid = (x + g) + (y + h) * roomsize
										if (unitmap[tileid] ~= nil) then
											for c,d in ipairs(unitmap[tileid]) do
												local unit = mmf.newObject(d)
												local name_ = unit.strings[UNITNAME]
												
												if (unit.strings[UNITTYPE] == "text") then
													name_ = "text"
												end
												
												if (name_ == b) then
													result = false
												end
											end
										end
									else
										local nearempty = true
								
										local tileid = (x + g) + (y + h) * roomsize
										if (unitmap[tileid] ~= nil) then 
											if (#unitmap[tileid] > 1) then
												nearempty = false
											end
										end
										
										if nearempty then
											result = false
										end
									end
								end
							end
						end
					else
						print("no parameters given!")
					end
				elseif (condtype == "alone") then
					valid = true
					
					local tileid = x + y * roomsize
					if (unitmap[tileid] ~= nil) then
						for c,d in ipairs(unitmap[tileid]) do
							if (d ~= unitid) then
								result = false
							end
						end
					end
				elseif (condtype == "not alone") then
					valid = true
					
					local tileid = x + y * roomsize
					if (unitmap[tileid] ~= nil) then
						if (#unitmap[tileid] == 1) then
							result = false
						end
					end
				end
			end
			
			if (valid == false) then
				print("invalid condition: " .. condtype)
				result = true
			end
		end
	end
	
	return result
end