function effects(timer)
	doeffect(timer,"win","unlock",1,2,20,{2,4})
	doeffect(timer,"best","unlock",6,30,2,{2,4})
	doeffect(timer,"tele","glow",1,5,20,{1,4})
	doeffect(timer,"hot","hot",1,80,10,{0,1})
	doeffect(timer,"bonus","bonus",1,2,20,{4,1})
	doeffect(timer,"wonder","wonder",1,10,5,{0,3})
	doeffect(timer,"sad","tear",1,2,20,{3,2})
	doeffect(timer,"sleep","sleep",1,5,30,{3,2})
end
	
function doeffect(timer,keyword,particle,count,chance,timing,colour)
	if (timer % timing == 0) then
		local this = findfeature(nil,"is",keyword)
		
		local c1 = colour[1]
		local c2 = colour[2]
		
		if (this ~= nil) then
			for k,v in ipairs(this) do
				if (v[1] ~= "empty") and (v[1] ~= "all") then
					local these = findall(v)
					
					if (#these > 0) then
						for a,b in ipairs(these) do
							local unit = mmf.newObject(b)
							local x,y = unit.values[XPOS],unit.values[YPOS]
							if unit.visible then
								for i=1,count do
									if (chance > 1) then
										if (math.random(chance) == 1) then
											MF_particle(particle,x,y,c1,c2)
										end
									else
										MF_particle(particle,x,y,c1,c2)
									end
								end
							end
						end
					end
				elseif (v[1] == "empty") then
					for i=1,roomsize-2 do
						for j=1,roomsize-2 do
							local tileid = i + j * roomsize
							
							if (unitmap[tileid] == nil) or ((unitmap[tileid] ~= nil) and (#unitmap[tileid] == 0)) then
								for f=1,count do
									if (chance > 1) then
										if (math.random(chance) == 1) then
											MF_particle(particle,i,j,c1,c2)
										end
									else
										MF_particle(particle,i,j,c1,c2)
									end
								end
							end
						end
					end
				end
			end
		end
	end
end

function particles(name,x,y,count,colour)
	MF_particles(name,x,y,count,colour[1],colour[2])
end

function domaprotation()
	if (maprotation ~= 0) then
		maprotation = 0
		MF_levelrotation(maprotation)
	end
	
	if (featureindex["level"] ~= nil) then
		for i,v in ipairs(featureindex["level"]) do
			local rule = v[1]
			local conds = v[2]
			
			if (#conds == 0) then
				if (rule[1] == "level") and (rule[2] == "is") then
					if (rule[3] == "down") then
						maprotation = 0
						MF_levelrotation(maprotation)
					elseif (rule[3] == "right") then
						maprotation = 90
						MF_levelrotation(maprotation)
					elseif (rule[3] == "up") then
						maprotation = 180
						MF_levelrotation(maprotation)
					elseif (rule[3] == "left") then
						maprotation = 270
						MF_levelrotation(maprotation)
					end
				end
			end
		end
	end
end

function levelparticles(name)
	local particletypes =
	{
		bubbles =
		{
			amount = 30,
			animation = 0,
			colour = {1, 0},
			extra = 
				function(unitid)
					local unit = mmf.newObject(unitid)
					
					unit.values[YVEL] = math.random(-3,-1)
					unit.values[7] = math.random(-10,10)
					
					unit.scaleX = unit.values[YVEL] * -0.33
					unit.scaleY = unit.values[YVEL] * -0.33
				end,
		},
		soot =
		{
			amount = 30,
			animation = 1,
			colour = {0, 1},
			extra = 
				function(unitid)
					local unit = mmf.newObject(unitid)
					
					unit.values[YVEL] = math.random(-3,-1)
					unit.values[7] = math.random(-10,10)
					
					unit.scaleX = unit.values[YVEL] * -0.33
					unit.scaleY = unit.values[YVEL] * -0.33
				end,
		},
		dust =
		{
			amount = 30,
			animation = 1,
			colour = {1, 0},
			extra = 
				function(unitid)
					local unit = mmf.newObject(unitid)
					
					unit.values[YVEL] = math.random(-3,-1)
					unit.values[7] = math.random(-10,10)
					
					unit.scaleX = unit.values[YVEL] * -0.33
					unit.scaleY = unit.values[YVEL] * -0.33
				end,
		},
	}
	
	if (particletypes[name] ~= nil) then
		local data = particletypes[name]
		
		if (data.customfunc == nil) then
			local amount = data.amount
			
			for i=1,amount do
				local unitid = MF_specialcreate("Level_particle")
				local unit = mmf.newObject(unitid)
				
				unit.values[ONLINE] = 1
				unit.x = math.random(0, roomsize * tilesize - 1)
				unit.y = math.random(0, roomsize * tilesize - 1)
				unit.layer = 1
				
				unit.values[XPOS] = unit.x
				unit.values[YPOS] = unit.y
				
				if (data.animation ~= nil) then
					unit.direction = data.animation
				end
				
				if (data.x_velocity ~= nil) then
					unit.values[XVEL] = data.x_velocity
				end
				
				if (data.y_velocity ~= nil) then
					unit.values[YVEL] = data.y_velocity
				end
				
				if (data.colour ~= nil) then
					local c = data.colour
					MF_setcolour(unitid,c[1],c[2])
				end
				
				unit.values[DIR] = math.random(0,259)
				unit.strings[1] = name
				
				if (data.extra ~= nil) then
					data.extra(unitid)
				end
			end
		else
			data.customfunc()
		end
	else
		print("No particles with name " .. name)
	end
end

function dotransition()
	local count = 36
	local initialdist = roomsize * tilesize * 0.75
	local pos = roomsize * tilesize * 0.5
	
	local increment = 360 / count
	
	for i=1,count do
		local blobid = MF_specialcreate("Transition_blob")
		local blob = mmf.newObject(blobid)
		
		local spd = 40 + math.random(-10,10)
		
		if (generaldata.values[FASTTRANSITION] == 1) then
			spd = 80 + math.random(-10,10)
		end
		
		blob.values[ONLINE] = 1
		blob.values[XPOS] = pos + math.cos(math.rad(increment) * i) * initialdist
		blob.values[YPOS] = pos - math.sin(math.rad(increment) * i) * initialdist
		blob.flags[10] = true
		MF_setcolour(blobid,1,0)
		
		local x,y = blob.values[XPOS],blob.values[YPOS]
		
		local dir = 0 - math.atan2(pos - y,pos - x)
		blob.values[XVEL] = math.cos(dir) * spd
		blob.values[YVEL] = 0 - math.sin(dir) * spd
		blob.layer = 2
	end
	
	local locations = {{-0.3,-0.3},{1.3,-0.3},{1.3,1.3},{-0.3,1.3},{-0.45,0.5},{0.5,-0.45},{1.45,0.5},{0.5,1.45}}
	
	for i=1,#locations do
		local blobid = MF_specialcreate("Transition_bigblob")
		local blob = mmf.newObject(blobid)
		
		local currloc = locations[i]
		
		blob.values[ONLINE] = 1
		blob.values[XPOS] = roomsize * tilesize * currloc[1]
		blob.values[YPOS] = roomsize * tilesize * currloc[2]
		blob.flags[10] = true
		MF_setcolour(blobid,1,0)
		
		local spd = 40
		
		if (generaldata.values[FASTTRANSITION] == 1) then
			spd = 80
		end
		
		local x,y = blob.values[XPOS],blob.values[YPOS]
		
		local dir = 0 - math.atan2(pos - y,pos - x)
		blob.values[XVEL] = math.cos(dir) * spd
		blob.values[YVEL] = 0 - math.sin(dir) * spd
		blob.layer = 2
	end
end