function newundo()
	if (updateundo == false) or (doundo == false) then
		table.remove(undobuffer, 1)
	end
	
	table.insert(undobuffer, 1, {})
	
	local thisundo = undobuffer[1]
	thisundo.wordunits = {}
	
	if (#wordunits > 0) then
		for i,v in ipairs(wordunits) do
			table.insert(thisundo.wordunits, v)
		end
	end
	
	updateundo = false
end

function addundo(line)
	if doundo then
		local currentundo = undobuffer[1]
		local text = tostring(#undobuffer) .. ", "
		
		table.insert(currentundo, 1, {})
		currentundo[1] = {}
		
		for i,v in ipairs(line) do
			table.insert(currentundo[1], v)
			text = text .. tostring(v) .. " "
		end
		
		--print(text)
	end
end


function undo()
	if (#undobuffer > 1) then
		local currentundo = undobuffer[2]
		
		if (currentundo ~= nil) then
			for i,line in ipairs(currentundo) do
				local style = line[1]
				
				if (style == "update") then
					local unitid = getunitid(line[9])
					local unit = mmf.newObject(unitid)
					
					local oldx,oldy = unit.values[XPOS],unit.values[YPOS]
					local x,y,dir = line[3],line[4],line[5]
					unit.values[XPOS] = x
					unit.values[YPOS] = y
					unit.values[DIR] = dir
					unit.values[POSITIONING] = 0
					
					updateunitmap(unitid,oldx,oldy,x,y)
					dynamic(unitid)
					dynamicat(oldx,oldy)
					
					local ox = math.abs(oldx-x)
					local oy = math.abs(oldy-y)
					
					if (ox + oy == 1) and (unit.values[TILING] == 2) then
						unit.values[VISUALDIR] = ((unit.values[VISUALDIR] - 1)+4) % 4
						unit.direction = unit.values[DIR] * 8 + unit.values[VISUALDIR]
					end
					
					if (unit.strings[UNITTYPE] == "text") then
						updatecode = 1
					end
					
					local undowordunits = currentundo.wordunits
					if (#undowordunits > 0) then
						for a,b in ipairs(undowordunits) do
							if (b == unitid) then
								updatecode = 1
								wordunits = undowordunits
							end
						end
					end
				elseif (style == "remove") then
					local x,y,dir = line[3],line[4],line[5]
					local name = line[2]
					local unitname = unitreference[name]
					local unitid = MF_emptycreate(unitname,x,y)
					
					local unit = mmf.newObject(unitid)
					unit.values[ONLINE] = 1
					unit.values[XPOS] = x
					unit.values[YPOS] = y
					unit.values[DIR] = dir
					unit.values[ID] = line[6]
					unit.flags[9] = true
					
					addunit(unitid)
					addunitmap(unitid,x,y)
					dynamic(unitid)
					
					if (unit.strings[UNITTYPE] == "text") then
						updatecode = 1
					end
					
					local undowordunits = currentundo.wordunits
					if (#undowordunits > 0) then
						for a,b in ipairs(undowordunits) do
							if (b == unitid) then
								updatecode = 1
								wordunits = undowordunits
							end
						end
					end
					
					local visibility = hasfeature(name,"is","hide",unitid)
					
					if (visibility ~= nil) then
						unit.visible = false
					end
				elseif (style == "create") then
					local unitid = getunitid(line[3])
					local unit = mmf.newObject(unitid)
					local x,y = unit.values[XPOS],unit.values[YPOS]
					local unittype = unit.strings[UNITTYPE]
					
					unit = {}
					delunit(unitid)
					MF_remove(unitid,0,2)
					dynamicat(x,y)
					
					if (unittype == "text") then
						updatecode = 1
					end
					
					local undowordunits = currentundo.wordunits
					if (#undowordunits > 0) then
						for a,b in ipairs(undowordunits) do
							if (b == unitid) then
								updatecode = 1
								wordunits = undowordunits
							end
						end
					end
				elseif (style == "done") then
					local unitid = line[7]
					print(unitid)
					local unit = mmf.newObject(unitid)
					
					unit.values[FLOAT] = line[3]
					unit.angle = 0
					unit.values[POSITIONING] = 0
					unit.flags[DEAD] = false
					
					print(unit.className .. ", " .. tostring(unitid) .. ", " .. tostring(line[3]) .. ", " .. unit.strings[UNITNAME])
					
					addunit(unitid)
				elseif (style == "visibility") then
					local unitid = getunitid(line[3])
					local unit = mmf.newObject(unitid)
					if (line[4] == 0) then
						unit.visible = true
					elseif (line[4] == 1) then
						unit.visible = false
					end
				end
			end
		end
		
		table.remove(undobuffer, 2)
	end
end

function undostate(state)
	if (state ~= nil) then
		doundo = state
	end
end 